1
1
Fork 0
Du kannst nicht mehr als 25 Themen auswählen Themen müssen entweder mit einem Buchstaben oder einer Ziffer beginnen. Sie können Bindestriche („-“) enthalten und bis zu 35 Zeichen lang sein.

73 Zeilen
1.2 KiB

vor 6 Jahren
#!/usr/bin/env bash
vor 6 Jahren
declare -r esc=$'\033'
declare -r c_reset="${esc}[0m"
declare -r c_red="${esc}[31m"
vor 6 Jahren
declare -r fifo='/tmp/sshget.fifo'
declare -A domains=()
declare -A paths=()
declare -a files=()
err() {
printf "${c_red}%s${c_reset}\n" "$*" >&2
}
die() {
exit 1
}
vor 6 Jahren
usage() {
LESS=-FEXR less <<'HELP'
sshget <user@host1:/path/to/search ...>
HELP
}
has() {
vor 6 Jahren
local verbose=0
if [[ $1 = '-v' ]]; then
vor 6 Jahren
verbose=1
shift
fi
vor 6 Jahren
for c; do c="${c%% *}"
if ! command -v "$c" &> /dev/null; then
vor 6 Jahren
(( verbose > 0 )) && err "$c not found"
return 1
fi
done
}
has -v fzf rsync || die
vor 6 Jahren
cleanup() {
[[ -e "$fifo" ]] && rm "$fifo"
}
trap cleanup SIGHUP SIGINT SIGTERM
mkfifo "$fifo"
vor 6 Jahren
if (( $# < 1 )); then
usage
die
fi
vor 6 Jahren
for a; do
vor 6 Jahren
host="${a%:*}"
vor 6 Jahren
path="${a##*:}"
domains+=( ["$a"]="$host" )
paths+=( ["$a"]="$path" )
shift
done
for s in "${!domains[@]}"; do
vor 6 Jahren
ssh "${domains[$s]}" "find ${paths[$s]}" | sed -r "s|^|${domains[$s]}:|" >> "$fifo" &
vor 6 Jahren
done
vor 4 Jahren
mapfile -t files < <(fzf -e --inline-info +s --multi --cycle --bind='Ctrl-A:toggle-all,`:jump' < "$fifo")
vor 6 Jahren
if (( ${#files[@]} )); then
rsync --protect-args -auvzP -e ssh "${files[@]}" .
vor 6 Jahren
fi
cleanup